(* ------------------------------------------------------ *)
(*                      TXT2MSK.PAS                       *)
(*          Ergnzt Textbildschirme um das Attribut       *)
(*              (c) 1991 W.Rinke & DMV-Verlag             *)
(* ------------------------------------------------------ *)
PROGRAM Txt2Msk;

USES Dos;

VAR
  Attr, ch  : BYTE;
  InFile,
  OutFile   : PathStr;
  Dir       : DirStr;
  Name      : NameStr;
  Ext       : ExtStr;
  InF, OutF : FILE OF BYTE;
  Code      : INTEGER;


  PROCEDURE Usage;
  BEGIN
    WriteLn('Aufruf: TXT2MSK <Dateiname> [Attribut]');
  END;

BEGIN
  CASE ParamCount OF
    1 : BEGIN
          Attr   := $07;         (* Default: schwarz/wei *)
          InFile := ParamStr(1);
        END;
    2 : BEGIN
          Val(ParamStr(2), Attr, Code);
          InFile := ParamStr(1);
        END;
  ELSE
    Usage;
    Halt(1);
  END;

  FSplit(InFile, Dir, Name, Ext);
  OutFile := Dir + Name + '.MSK';

  Assign(InF, InFile);
{$I-}
  Reset(InF);
{$I+}
  IF IOResult <> 0 THEN BEGIN
    WriteLn(InFile, ' nicht gefunden.');
    Halt(2);
  END;
  Assign(OutF, OutFile);
  Rewrite(OutF);

  WHILE NOT EoF(InF) DO BEGIN
    Read(InF, ch);
    IF ch > 31 THEN Write(OutF, ch, Attr);
  END;

  Close(InF);  Close(OutF);
END.
(* ------------------------------------------------------ *)
(*                 Ende von TXT2MSK.PAS                   *)
