(* ------------------------------------------------------ *)
(*                      ZKETTEN.PAS                       *)
(*  enthlt Prozeduren und Funktionen zur vollstndigen   *)
(*  Kapselung der systemabhngigen Ein-, Aus- und         *)
(*  Verarbeitungsfunktionen fr Strings.                  *)
(*        (c) 1991 Andreas Tengicki & DMV-Verlag          *)
(* ------------------------------------------------------ *)
UNIT Zketten;

INTERFACE

  PROCEDURE InpStr (VAR Text : STRING);
  PROCEDURE InpChr (VAR c    : CHAR);
  PROCEDURE GetChr (VAR c    : CHAR);

  FUNCTION  InStr  (Such, Text : STRING) : INTEGER;
  FUNCTION  TeilStr(Such     : STRING;
                    von, bis : INTEGER) : STRING;
  FUNCTION  CatStr (Text1, Text2 : STRING) : STRING;
  FUNCTION  LenStr (Text : STRING) : INTEGER;


IMPLEMENTATION


  PROCEDURE InpStr(VAR Text : STRING);
    (* liest eine Zeile ber die Tastatur *)
  BEGIN
    ReadLn(Text);
  END;

  PROCEDURE InpChr(VAR c : CHAR);
    (* liest ein Zeichen (1 Zeile) ber die Tastatur *)
  BEGIN
    ReadLn(c);
  END;

  PROCEDURE getchr(VAR c:CHAR);
    (* liest ein Zeichen einer Zeichenfolge ber die Tastatur *)
  BEGIN
    Read(c);
  END;

  FUNCTION InStr(Such, Text : STRING) : INTEGER;
    (* bestimmt die Position des SUCHtextes im TEXT. *)
    (* Position Null bedeutet: nicht gefunden.       *)
  BEGIN
    InStr := Pos(Such, Text);
  END;

  FUNCTION TeilStr(Such     : STRING;
                   Von, Bis : INTEGER) : STRING;
    (* liefert den Teilstring von TEXT zwischen *)
    (* den Positionen VON und BIS.              *)
  BEGIN
    TeilStr := Copy(Such, Von, Bis - Von + 1);
  END;

  FUNCTION CatStr(Text1, Text2 : STRING) : STRING;
    (* Kopiert zwei Zeichenketten aneinander *)
  BEGIN
    CatStr := Concat(Text1, Text2);
  END;

  FUNCTION LenStr(Text : STRING) : INTEGER;
    (* liefert die echte Lnge eines Strings. *)
  BEGIN
    LenStr := Length(Text);
  END;

END.
(* ------------------------------------------------------ *)
(*               Ende von ZKETTEN.PAS                     *)
